Index: cpp/frams/genetics/f4/f4_oper.cpp
===================================================================
--- cpp/frams/genetics/f4/f4_oper.cpp	(revision 1226)
+++ cpp/frams/genetics/f4/f4_oper.cpp	(revision 1227)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2023  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -6,4 +6,18 @@
 // Copyright (C) since 2001 Maciej Komosinski
 // 2018, Grzegorz Latosinski, added support for new API for neuron types and their properties
+
+
+// This representation has a tendency to bloat - adding a small penalty to fitness such as "this.velocity - 0.000000001*String.len(this.genotype);"
+// may help, but it would be better to improve the source code to make genetic operators neutral in terms of genotype length. Adding such a penalty
+// removes "work in progress" changes in genotypes thus promoting immediate, straightforward improvements while hindering slower, multifaceted progress.
+// TODO getting rid of redundancy (having valid genotypes with a lot of "junk code") in this representation looks like a good idea.
+// 
+// Note: symbols after the last > are ignored, for example /*4*/<X>N:N>N:N[2:-0.5]XXXwhatever but since they are not parsed into the f4_Node tree, they will be lost after any mutation.
+//
+// TODO the behavior of neuron input indexes during mutation seems badly implemented (see also TREAT_BAD_CONNECTIONS_AS_ERRORS). Are they kept properly maintained when nodes are added and removed? This could be done well because during mutation we operate on the tree structure with cross-references between nodes (so they should not be affected by local changes in the tree), and then convert the tree back to string. Yet, the f4_Node.conn_from is an integer and these fields in nodes do not seem to be maintained on tree node adding/removal... change these integer offsets to references to node objects? But actually, do the offsets that constitute relative connection references concern the f4_Node tree structure (and all these sophisticated calculations of offsets during mutation are useful) or rather they concern the f4_Cells development? verify all situations in f4_Cell::oneStep(), case '['.
+// TODO add simplifying sequences of modifiers (so capital and small letter cancel out, like in f1) - but seems like each single modifier is a separate f4_Node? and perhaps we don't want to use the repair mechanism for this... maybe mutations, when they add/modify/remove a modifier node, should be "cleaning" the tree by removing nodes when they encounter contradictory modifiers on the same subpath?
+// TODO add support for properties of (any class of) neurons - not just sigmoid/force/intertia (':' syntax) for N
+// TODO add mapping genotype character ranges for neural [connections]
+
 
 #include "f4_oper.h"
@@ -20,6 +34,5 @@
 
 // codes that can be changed (apart from being added/deleted)
-#define MUT_CHAN_CODES "<[#"
-#define REP_MAXCOUNT 19
+#define F4_MUT_CHANGE_CODES "<[#"
 
 #define FIELDSTRUCT Geno_f4
@@ -27,13 +40,19 @@
 static ParamEntry geno_f4_paramtab[] =
 {
-	{ "Genetics: f4", 1, F4_COUNT + F4_ADD_COUNT + 1, },
-	{ "f4_mut_add", 0, 0, "Add node", "f 0 100 50", FIELD(prob[F4_ADD]), "mutation: probability of adding a node", },
-	{ "f4_mut_add_div", 0, 0, "- add division", "f 0 100 20", FIELD(probadd[F4_ADD_DIV]), "add node mutation: probability of adding a division", },
-	{ "f4_mut_add_conn", 0, 0, "- add connection", "f 0 100 15", FIELD(probadd[F4_ADD_CONN]), "add node mutation: probability of adding a neural connection", },
-	{ "f4_mut_add_neupar", 0, 0, "- add neuron property", "f 0 100 5", FIELD(probadd[F4_ADD_NEUPAR]), "add node mutation: probability of adding a neuron property/modifier", },
-	{ "f4_mut_add_rep", 0, 0, "- add repetition", "f 0 100 10", FIELD(probadd[F4_ADD_REP]), "add node mutation: probability of adding a repetition", },
-	{ "f4_mut_add_simp", 0, 0, "- add simple node", "f 0 100 50", FIELD(probadd[F4_ADD_SIMP]), "add node mutation: probability of adding a random, simple gene", },
-	{ "f4_mut_del", 0, 0, "Delete node", "f 0 100 20", FIELD(prob[F4_DEL]), "mutation: probability of deleting a node", },
-	{ "f4_mut_mod", 0, 0, "Modify node", "f 0 100 30", FIELD(prob[F4_MOD]), "mutation: probability of changing a node", },
+	{ "Genetics: f4", 1, F4_COUNT + F4_ADD_COUNT + F4_MODNEU_COUNT + 2, },
+	{ "f4_mut_add", 0, 0, "Add node", "f 0 100 50", FIELD(prob[F4_ADD]), "Mutation: probability of adding a node", },
+	{ "f4_mut_add_div", 0, 0, "- add division", "f 0 100 20", FIELD(probadd[F4_ADD_DIV]), "Add node mutation: probability of adding a division", },
+	{ "f4_mut_add_conn", 0, 0, "- add connection", "f 0 100 15", FIELD(probadd[F4_ADD_CONN]), "Add node mutation: probability of adding a neural connection", },
+	{ "f4_mut_add_neupar", 0, 0, "- add neuron property", "f 0 100 5", FIELD(probadd[F4_ADD_NEUPAR]), "Add node mutation: probability of adding a neuron property/modifier", },
+	{ "f4_mut_add_rep", 0, 0, "- add repetition '#'", "f 0 100 10", FIELD(probadd[F4_ADD_REP]), "Add node mutation: probability of adding the '#' repetition gene", },
+	{ "f4_mut_add_simp", 0, 0, "- add simple node", "f 0 100 50", FIELD(probadd[F4_ADD_SIMP]), "Add node mutation: probability of adding a random, simple gene", },
+
+	{ "f4_mut_del", 0, 0, "Delete node", "f 0 100 20", FIELD(prob[F4_DEL]), "Mutation: probability of deleting a node", },
+
+	{ "f4_mut_mod", 0, 0, "Modify node", "f 0 100 30", FIELD(prob[F4_MOD]), "Mutation: probability of changing a node", },
+	{ "f4_mut_modneu_conn", 0, 0, "- neuron input: modify source", "f 0 100 60", FIELD(probmodneu[F4_MODNEU_CONN]), "Neuron input mutation: probability of changing its source neuron", },
+	{ "f4_mut_modneu_weight", 0, 0, "- neuron input: modify weight", "f 0 100 40", FIELD(probmodneu[F4_MODNEU_WEIGHT]), "Neuron input mutation: probability of changing its weight", },
+
+	{ "f4_mut_max_rep", 1, 0, "Maximum number for '#' repetitions", "d 2 20 6", FIELD(mut_max_rep), "Maximum allowed number of repetitions for the '#' repetition gene", },
 	{ "f4_mut_exmod", 1, 0, "Excluded modifiers", "s 0 30", FIELD(excluded_modifiers), "Modifiers that will not be added nor deleted during mutation\n(all: " F14_MODIFIERS ")", },
 	{ 0, },
@@ -59,5 +78,5 @@
 	mutation_method_names[index++] = "deleted a node";
 	mutation_method_names[index++] = "modified a node";
-	if (index != F4_COUNT + F4_ADD_COUNT - 1) logMessage("Geno_f4", "Constructor", 3, "Mutation names init error");
+	if (index != F4_COUNT + F4_ADD_COUNT - 1) logMessage("Geno_f4", "Constructor", LOG_CRITICAL, "Mutation names init error");
 }
 
@@ -67,5 +86,5 @@
 }
 
-int Geno_f4::ValidateRec(f4_node *geno, int retrycount) const
+int Geno_f4::ValidateRec(f4_Node *geno, int retrycount) const
 {
 	// ! the genotype is geno->child (not geno) !
@@ -76,11 +95,11 @@
 
 	// errors not fixed:
-	if (GENOPER_OPFAIL == cells.geterror())
-	{
-		if (cells.geterrorpos() >= 0) return 1 + cells.geterrorpos();
+	if (cells.getErrorCode() == GENOPER_OPFAIL)
+	{
+		if (cells.getErrorPos() >= 0) return 1 + cells.getErrorPos();
 		return GENOPER_OPFAIL;
 	}
 	// errors can be fixed
-	if (GENOPER_REPAIR == cells.geterror())
+	if (cells.getErrorCode() == GENOPER_REPAIR)
 	{
 		cells.repairGeno(geno, 1);
@@ -102,5 +121,5 @@
 {
 	// convert geno to tree, then try to validate 20 times
-	f4_node root;
+	f4_Node root;
 	if (f4_processrec(geno, 0, &root) || root.childCount() != 1) return GENOPER_OK; // cannot repair
 	if (ValidateRec(&root, 20) == GENOPER_REPAIR) // if repaired, make it back to string
@@ -115,5 +134,5 @@
 int Geno_f4::checkValidity(const char* geno, const char *genoname)
 {
-	f4_node root;
+	f4_Node root;
 	int res = f4_processrec(geno, 0, &root);
 	if (res) return res;  // errorpos, >0
@@ -121,7 +140,7 @@
 	f4_Cells cells(root.child, 0);
 	cells.simulate();
-	if (cells.geterror() == GENOPER_OPFAIL || cells.geterror() == GENOPER_REPAIR)
-	{
-		if (cells.geterrorpos() >= 0) return 1 + cells.geterrorpos();
+	if (cells.getErrorCode() == GENOPER_OPFAIL || cells.getErrorCode() == GENOPER_REPAIR)
+	{
+		if (cells.getErrorPos() >= 0) return 1 + cells.getErrorPos();
 		else return 1; //earlier: GENOPER_OPFAIL;
 	}
@@ -130,5 +149,5 @@
 
 
-int Geno_f4::MutateOne(f4_node *& g, int &method) const
+int Geno_f4::MutateOne(f4_Node *& g, int &method) const
 {
 	// ! the genotype is g->child (not g) !
@@ -136,8 +155,6 @@
 	// do the mutation
 	// pick a random node
-	f4_node *n1 = g->child->randomNode();
-	vector<NeuroClass*> neulist;
-	//DB( printf("%c\n", n1->name); )
-	int neuronid = -1;
+	f4_Node *node_mutated = g->child->randomNode();
+	//DB( printf("%c\n", node_mutated->name); )
 
 	switch (roulette(prob, F4_COUNT))
@@ -151,138 +168,136 @@
 		{
 			// add division ('<')
-			f4_node *n3 = n1->parent;
-			n3->removeChild(n1);
-			f4_node *n2 = new f4_node('<', n3, n3->pos);
-			n2->addChild(n1);
+			f4_Node *node_mutated_parent = node_mutated->parent;
+			node_mutated_parent->removeChild(node_mutated);
+			f4_Node *node_new_div = new f4_Node('<', node_mutated_parent, node_mutated_parent->pos);
+			node_new_div->addChild(node_mutated);
 			// new cell is stick or neuron
 			// "X>" or "N>"
-			f4_node *n5 = NULL;
-			double pr = rndDouble(1);
-			pr -= 0.5;
-			if (pr < 0) n5 = new f4_node('X', n2, n2->pos);
+			constexpr double STICK_OR_NEURON = 0.5; // hardcoded probability... could be parametrized, but in a general case (unknown fitness goal) 0.5 makes sense?
+			f4_Node *node_new = NULL; //stick or neuron or neural connection
+			if (rndDouble(1) < STICK_OR_NEURON)
+				node_new = new f4_Node('X', node_new_div, node_new_div->pos);
 			else
 			{
 				// make neuron
 				NeuroClass *rndclass = GenoOperators::getRandomNeuroClass(Model::SHAPETYPE_BALL_AND_STICK);
-				if (rndclass == NULL)
+				if (rndclass == NULL) //no active neurons?
 				{
-					n5 = new f4_node('X', n2, n2->pos);
+					node_new = new f4_Node('X', node_new_div, node_new_div->pos);
 				}
 				else
 				{
-					f4_node *n4 = new f4_node(rndclass->getName().c_str(), n2, n2->pos);
-					if (rndclass->getPreferredInputs() != 0)
+					f4_Node *node_new_neuron = new f4_Node(rndclass->getName().c_str(), node_new_div, node_new_div->pos);
+					node_new_neuron->neuclass = rndclass;
+					node_new = node_new_neuron; //can be changed below if all goes well and we add a new connection too
+					if (probadd[F4_ADD_CONN] > 0) //user wants to add connections
 					{
-						neuronid = -1;
-						for (int i = 0; i < g->count(); i++)
+						if (rndclass->getPreferredInputs() != 0) //neuron also wants connections?
 						{
-							f4_node *gcur = g->ordNode(i);
-							char* temp = (char*)gcur->name.c_str();
-							NeuroClass *neuclass = GenoOperators::parseNeuroClass(temp);
-							if (neuclass != NULL)
+							int node_new_neuron_index, other_neuron_index;
+							bool ok = findConnectionNeuronIndexes(g, node_new_neuron, true, node_new_neuron_index, other_neuron_index); //node_new_neuron_index==-1 should never happen, we just added node_new_neuron we are looking for
+							if (ok) //we can create a new connection
 							{
-								neulist.push_back(neuclass);
-							}
-							if (g->ordNode(i) == n3)
-							{
-								neuronid = int(neulist.size()) - 1;
+								node_new = new f4_Node('[', node_new_neuron, node_new_div->pos);
+								connectionNodeChangeRandom(node_new, node_new_neuron_index, other_neuron_index);
 							}
 						}
-						if (neuronid == -1)
+						else if (rndclass->getPreferredOutput() > 0) //neuron also wants connections?
 						{
-							return GENOPER_OPFAIL;
+							// Not so easy: we would need to add a '[' node as a child not of node_new_neuron, but of other neuron that would get an input from node_new_neuron (and need to properly calculate relative connection reference).
+							// The "false" argument in findConnectionNeuronIndexes() below is not suffient, because we also need to access (find) the f4_Node of the other neuron.
+							// A similar logic is implemented in F4_ADD_CONN below, but let's not complicate this F4_ADD_DIV mutation anymore.
+							// A disadvantage is that the node_new_neuron added here which is a neuron that provides output (e.g., a receptor, N, etc.) will not get connected immediately here even when there are already existing neurons wanting inputs (e.g., muscles, N, etc.).
+							//bool ok = findConnectionNeuronIndexes(g, ... , false, ..., ...);
 						}
-						n5 = new f4_node('[', n4, n2->pos);
-						linkNodeMakeRandom(n5, neuronid, neulist);
-					}
-					else {
-						n5 = n4;
 					}
 				}
 			}
-			new f4_node('>', n5, n5->pos);
-			n1->parent = n2;
-			// now with 50% chance swap children
+			new f4_Node('>', node_new, node_new->pos); //adds to node_new
+			node_mutated->parent = node_new_div;
+			// now, swap children with 50% chance
 			if (rndUint(2) == 0)
 			{
-				n3 = n2->child;
-				n2->child = n2->child2;
-				n2->child2 = n3;
-			}
-		}
-			break;
+				node_mutated_parent = node_new_div->child;
+				node_new_div->child = node_new_div->child2;
+				node_new_div->child2 = node_mutated_parent;
+			}
+		}
+		break;
 		case F4_ADD_CONN:
 		{
-			// add link
-			f4_node *par = n1->parent;
-			char* temp = (char*)par->name.c_str();
-			NeuroClass *neuclass = GenoOperators::parseNeuroClass(temp);
-			if (neuclass != NULL)
-			{
-				n1->parent->removeChild(n1);
-				f4_node *n2 = new f4_node('[', n1->parent, n1->parent->pos);
-				n2->addChild(n1);
-				n1->parent = n2;
-				neuronid = -1;
-				for (int i = 0; i < g->count(); i++)
-				{
-					f4_node *gcur = g->ordNode(i);
-					temp = (char*)gcur->name.c_str();
-					NeuroClass *neuclass = GenoOperators::parseNeuroClass(temp);
-					if (neuclass != NULL)
-					{
-						neulist.push_back(neuclass);
-					}
-					if (gcur == par)
-					{
-						neuronid = int(neulist.size()) - 1;
-					}
-				}
-				if (neuronid == -1)
-				{
-					return GENOPER_OPFAIL;
-				}
-				linkNodeMakeRandom(n2, neuronid, neulist);
-			}
-		}
-			break;
+			// add connection
+
+			// the probability that a randomly selected node will be a neuron and additionally this neuron will accept inputs is low,
+			// so we disregard randomly picked node_mutated and build a list of all valid candidate nodes here, then select a random one from them.
+
+			vector<f4_Node*> candidate_nodes; //neurons that accept input(s)
+			for (int i = 0; i < g->count(); i++)
+			{
+				f4_Node *node = g->ordNode(i);
+				f4_Node *node_parent = node->parent;
+				if (node_parent == NULL || node_parent->neuclass == NULL) continue;
+				int prefinputs = node_parent->neuclass->getPreferredInputs();
+				if (prefinputs == -1 ||
+					prefinputs > 0) //would be nice if we could easily and quickly check if the parent already has its preferred inputs used, so that we do not produce an invalid mutation here... it is possible through the f4_Cell.n_conns field, but only during organism development
+					candidate_nodes.push_back(node);
+			}
+
+			if (candidate_nodes.size() == 0)
+				return GENOPER_OPFAIL;
+
+			node_mutated = candidate_nodes[rndUint((unsigned int)candidate_nodes.size())];
+			f4_Node *node_mutated_parent = node_mutated->parent;
+
+			int node_mutated_parent_index, other_neuron_index;
+			bool ok = findConnectionNeuronIndexes(g, node_mutated_parent, true, node_mutated_parent_index, other_neuron_index); //node_mutated_parent_index==-1 should never happen, we earlier selected the neuron we are now looking for
+			if (!ok)
+				return GENOPER_OPFAIL;
+
+			node_mutated->parent->removeChild(node_mutated); //this subtree will be reconnected below, as a child to node_new_conn
+			f4_Node *node_new_conn = new f4_Node('[', node_mutated->parent, node_mutated->parent->pos);
+			node_new_conn->addChild(node_mutated);
+			node_mutated->parent = node_new_conn; // node_mutated_parent is the neuron, node_mutated->parent is '['
+			connectionNodeChangeRandom(node_new_conn, node_mutated_parent_index, other_neuron_index);
+		}
+		break;
 		case F4_ADD_NEUPAR:
 		{
 			// add neuron modifier
-			n1->parent->removeChild(n1);
-			f4_node *n2 = new f4_node(':', n1->parent, n1->parent->pos);
+			node_mutated->parent->removeChild(node_mutated);
+			f4_Node *n2 = new f4_Node(':', node_mutated->parent, node_mutated->parent->pos);
 			nparNodeMakeRandom(n2);
-			n2->addChild(n1);
-			n1->parent = n2;
-		}
-			break;
+			n2->addChild(node_mutated);
+			node_mutated->parent = n2;
+		}
+		break;
 		case F4_ADD_REP:
 		{
 			// add repetition ('#')
-			// repeated code (left child) is the original, right child is empty, count is 2
-			f4_node *n3 = n1->parent;
-			n3->removeChild(n1);
-			f4_node *n2 = new f4_node('#', n3, n3->pos);
-			n2->i1 = 2;
-			n2->addChild(n1);
-			new f4_node('>', n2, n2->pos);
-			n1->parent = n2;
-		}
-			break;
+			// repeated code (left child) is the original, right child is empty, count is set to 2
+			f4_Node *n3 = node_mutated->parent;
+			n3->removeChild(node_mutated);
+			f4_Node *n2 = new f4_Node('#', n3, n3->pos);
+			n2->reps = 2;
+			n2->addChild(node_mutated);
+			new f4_Node('>', n2, n2->pos);
+			node_mutated->parent = n2;
+		}
+		break;
 		case F4_ADD_SIMP:
 		{
 			// add simple node
 			// choose a simple node from ADD_SIMPLE_CODES
-			n1->parent->removeChild(n1);
-			//f4_node *n2 = new f4_node(ADD_SIMPLE_CODES[rndUint(strlen(ADD_SIMPLE_CODES))], n1->parent, n1->parent->pos);
+			node_mutated->parent->removeChild(node_mutated);
+			//f4_Node *n2 = new f4_Node(ADD_SIMPLE_CODES[rndUint(strlen(ADD_SIMPLE_CODES))], n1->parent, n1->parent->pos);
 			int modifierid = GenoOperators::getRandomChar(all_modifiers, excluded_modifiers.c_str());
-			f4_node *n2 = new f4_node(all_modifiers[modifierid], n1->parent, n1->parent->pos);
-			n2->addChild(n1);
-			n1->parent = n2;
-		}
-			break;
-		}
-	}
+			f4_Node *n2 = new f4_Node(all_modifiers[modifierid], node_mutated->parent, node_mutated->parent->pos);
+			n2->addChild(node_mutated);
+			node_mutated->parent = n2;
+		}
 		break;
+		}
+	}
+	break;
 
 	case F4_DEL:
@@ -294,72 +309,72 @@
 		for (int i = 0; i < 10; i++)
 		{
-			if ((NULL != n1->parent) && (g != n1->parent))
-				if (NULL != n1->child)
+			if ((node_mutated->parent != NULL) && (g != node_mutated->parent))
+				if (node_mutated->child != NULL)
 					break;
 			// try a new one
-			n1 = g->child->randomNode();
-		}
-		if ((NULL != n1->parent) && (g != n1->parent))
-		{
-			switch (n1->childCount())
+			node_mutated = g->child->randomNode();
+		}
+		if ((node_mutated->parent != NULL) && (g != node_mutated->parent))
+		{
+			switch (node_mutated->childCount())
 			{
 			case 0: break;
 			case 1:  // one child
 			{
-				f4_node *n2 = n1->parent;
-				n2->removeChild(n1);
-				if (NULL != n1->child)
+				f4_Node *node_mutated_parent = node_mutated->parent;
+				node_mutated_parent->removeChild(node_mutated);
+				if (node_mutated->child != NULL)
 				{
-					n1->child->parent = n2;
-					n2->addChild(n1->child);
-					n1->child = NULL;
+					node_mutated->child->parent = node_mutated_parent;
+					node_mutated_parent->addChild(node_mutated->child);
+					node_mutated->child = NULL;
 				}
-				if (NULL != n1->child2)
+				if (node_mutated->child2 != NULL)
 				{
-					n1->child2->parent = n2;
-					n2->addChild(n1->child2);
-					n1->child2 = NULL;
+					node_mutated->child2->parent = node_mutated_parent;
+					node_mutated_parent->addChild(node_mutated->child2);
+					node_mutated->child2 = NULL;
 				}
 				// destroy n1
-				n1->parent = NULL;
-				delete n1;
-			}
-				break;
+				node_mutated->parent = NULL;
+				delete node_mutated;
+			}
+			break;
 
 			case 2:  // two children
 			{
 				// two children
-				f4_node *n2 = n1->parent;
-				n2->removeChild(n1);
+				f4_Node *n2 = node_mutated->parent;
+				n2->removeChild(node_mutated);
 				// n1 has two children. pick one randomly 50-50, destroy other
 				if (rndUint(2) == 0)
 				{
-					n1->child->parent = n2;
-					n2->addChild(n1->child);
-					n1->child = NULL;
-					n1->child2->parent = NULL;
+					node_mutated->child->parent = n2;
+					n2->addChild(node_mutated->child);
+					node_mutated->child = NULL;
+					node_mutated->child2->parent = NULL;
 				}
 				else
 				{
-					n1->child2->parent = n2;
-					n2->addChild(n1->child2);
-					n1->child2 = NULL;
-					n1->child->parent = NULL;
+					node_mutated->child2->parent = n2;
+					n2->addChild(node_mutated->child2);
+					node_mutated->child2 = NULL;
+					node_mutated->child->parent = NULL;
 				}
 				// destroy n1
-				n1->parent = NULL;
-				delete n1;
-			}
-				break;
+				node_mutated->parent = NULL;
+				delete node_mutated;
+			}
+			break;
 			}
 		}
 		else return GENOPER_OPFAIL;
 	}
-		break;
+	break;
 	case F4_MOD:
 	{
 		method = F4_ADD_COUNT - 1 + F4_MOD;
 		// change a node
-		// the only nodes that are modifiable are MUT_CHAN_CODES
+		// the only nodes that are modifiable are F4_MUT_CHANGE_CODES
 		// try to get a modifiable node
 		// already picked a node, but repeat may be needed
@@ -367,168 +382,130 @@
 		while (1)
 		{
-			if (strchr(MUT_CHAN_CODES, n1->name[0])) break;
+			if (strchr(F4_MUT_CHANGE_CODES, node_mutated->name[0])) break;
 			// try a new one
-			n1 = g->child->randomNode();
+			node_mutated = g->child->randomNode();
 			i++;
 			if (i >= 20) return GENOPER_OPFAIL;
 		}
-		switch (n1->name[0])
+		switch (node_mutated->name[0])
 		{
 		case '<':
 		{
 			// swap children
-			f4_node *n2 = n1->child; n1->child = n1->child2; n1->child2 = n2;
-		}
-			break;
+			f4_Node *n2 = node_mutated->child;
+			node_mutated->child = node_mutated->child2;
+			node_mutated->child2 = n2;
+		}
+		break;
 		case '[':
 		{
-			neuronid = -1;
-			for (int i = 0; i < g->count(); i++)
-			{
-				f4_node *gcur = g->ordNode(i);
-				char *temp = (char*)gcur->name.c_str();
-				NeuroClass *neuclass = GenoOperators::parseNeuroClass(temp);
-				if (neuclass != NULL)
-				{
-					neulist.push_back(neuclass);
-				}
-				if (gcur == n1)
-				{
-					neuronid = int(neulist.size()) - 1;
-				}
-			}
-			if (neuronid == -1)
-			{
-				return GENOPER_OPFAIL;
-			}
-			linkNodeChangeRandom(n1, neuronid, neulist);
-		}
-			break;
+			switch (roulette(probmodneu, F4_MODNEU_COUNT))
+			{
+			case F4_MODNEU_CONN:
+			{
+				f4_Node *neuron = node_mutated; //we start in '[' node and follow up parents until we find the neuron with these connections
+				while (neuron != NULL && neuron->neuclass == NULL) neuron = neuron->parent;
+				if (neuron == NULL)
+					return GENOPER_OPFAIL; //did not find a neuron on the way up tree
+
+
+				int neuron_index, other_neuron_index;
+				bool ok = findConnectionNeuronIndexes(g, neuron, true, neuron_index, other_neuron_index); //neuron_index==-1 should never happen, we know the neuron is in the tree
+				if (!ok)
+					return GENOPER_OPFAIL;
+
+				connectionNodeChangeRandom(node_mutated, neuron_index, other_neuron_index);
+				break;
+			}
+			case F4_MODNEU_WEIGHT:
+				node_mutated->conn_weight = GenoOperators::getMutatedNeuronConnectionWeight(node_mutated->conn_weight);
+				break;
+			}
+		}
+		break;
 
 		case '#':
 		{
-			repeatNodeChangeRandom(n1);
-		}
-			break;
-		}
-	}
+			repeatNodeChangeRandom(node_mutated);
+		}
 		break;
+		}
+	}
+	break;
 
 	default: //no mutations allowed?
 		return GENOPER_OPFAIL;
 	}
-
 	return GENOPER_OK;
 }
 
-// make a random [ node
-void Geno_f4::linkNodeMakeRandom(f4_node *nn, int neuid, vector<NeuroClass*> neulist) const
-{
-	float prob1;
-	NeuroClass *nc = NULL;
-
-	// 35% chance one of *GTS
-	prob1 = rndDouble(1);
-	prob1 -= 0.35f;
-	if (prob1 < 0)
-	{
-		// '*', 'G', 'T', or 'S', 1/4 chance each
-		nc = GenoOperators::getRandomNeuroClassWithOutputAndNoInputs(Model::SHAPETYPE_BALL_AND_STICK);
-	}
-	if (nc != NULL)
-	{
-		nn->i1 = 1;
-		nn->s1 = nc->getName().c_str();
-		nn->l1 = 0;
-	}
-	else
-	{
-		// relative input link
-		int id = GenoOperators::getRandomNeuroClassWithOutput(neulist);
-		int relid = neuid - id;
-		nn->l1 = relid;
-		//nn->l1 = (int)(4.0f * (rndDouble(1) - 0.5f));
-	}
-	// weight
-	nn->f1 = GenoOperators::getMutatedNeuronConnectionWeight(nn->f1);
-	//nn->f1 = 10.0f * (rndDouble(1) - 0.5f);
+// find all neurons and the needle
+vector<NeuroClass*> Geno_f4::findAllNeuronsAndNode(f4_Node * const & g, f4_Node* const &needle_neuron, int &found_index)
+{
+	found_index = -1; // not found (for example, needle_neuron is not a neuroclass node or not added to the "g" tree)
+	vector<NeuroClass*> neulist;
+	for (int i = 0; i < g->count(); i++)
+	{
+		f4_Node *node = g->ordNode(i);
+		if (node->neuclass != NULL)
+		{
+			neulist.push_back(node->neuclass);
+			if (node == needle_neuron)
+				found_index = int(neulist.size()) - 1;
+		}
+	}
+	return neulist;
+}
+
+bool Geno_f4::findConnectionNeuronIndexes(f4_Node * const &g, f4_Node *neuron, bool other_has_output, int &neuron_index, int &other_neuron_index)
+{
+	vector<NeuroClass*> neulist = findAllNeuronsAndNode(g, neuron, neuron_index);
+	if (neuron_index == -1)
+		return false;
+
+	other_neuron_index = other_has_output ?
+		GenoOperators::getRandomNeuroClassWithOutput(neulist) //find an existing neuron that provides an output
+		:
+		GenoOperators::getRandomNeuroClassWithInput(neulist); //find an existing neuron that accepts input(s)
+	return other_neuron_index >= 0;
 }
 
 // change a [ node
-void Geno_f4::linkNodeChangeRandom(f4_node *nn, int neuid, std::vector<NeuroClass*> neulist) const      //rewritten by M.K. - should work as before (not tested)
-{
-	double probs[3] = { 0.1, 0.3, 0.6 };
-	NeuroClass *cl;
-	// 10% change type
-	// 30% change link
-	// 60% change weight
-
-	switch (roulette(probs, 3))
-	{
-	case 0: // change type
-		// 80% for link, 20% for random sensor
-		if (rndDouble(1) < 0.2f)
-		{
-			cl = GenoOperators::getRandomNeuroClassWithOutputAndNoInputs(Model::SHAPETYPE_BALL_AND_STICK);
-			if (cl != NULL)
-			{
-				nn->i1 = 1;
-				nn->s1 = cl->name.c_str();
-				nn->l1 = 0;
-			}
-		}
-		break;
-	case 1: // change link
-		if (0 == nn->i1) // relative input link
-		{
-			int id = GenoOperators::getRandomNeuroClassWithOutput(neulist);
-			nn->l1 = neuid - id;
-		}
-		//nn->l1 += (int)(2.0f * (rndDouble(1) - 0.5f));
-		break;
-	case 2: // change weight
-		nn->f1 = GenoOperators::getMutatedNeuronConnectionWeight(nn->f1);
-		//nn->f1 += 1.0f * (rndDouble(1) - 0.5f);
-		break;
-	}
-}
+void Geno_f4::connectionNodeChangeRandom(f4_Node *nn, int nn_index, int other_index) const
+{
+	// relative input connection to some existing neuron
+	nn->conn_from = nn_index - other_index;
+	//nn->conn_from = (int)(4.0f * (rndDouble(1) - 0.5f)); //in very old times - did not care about neuron input/output preferences
+
+	nn->conn_weight = GenoOperators::getMutatedNeuronConnectionWeight(nn->conn_weight);
+}
+
 
 // make a random : node
-void Geno_f4::nparNodeMakeRandom(f4_node *nn) const
-{
-	int sign = (int)rndDouble(2);
-	int param = (int)rndDouble(3);
-	if (param > 2) param = 2;
-	nn->l1 = sign;
-	nn->i1 = "!=/"[param];
+void Geno_f4::nparNodeMakeRandom(f4_Node *nn) const
+{
+	unsigned int prop = rndUint(3); //random neuron property
+	nn->prop_symbol = "!=/"[prop];
+	nn->prop_increase = rndUint(2) == 1;
 }
 
 // change a repeat # node
-void Geno_f4::repeatNodeChangeRandom(f4_node *nn) const
-{
-	int count;
-	float prob1;
-
-	// change count
-	count = nn->i1;
-	prob1 = rndDouble(1);
-	if (prob1 < 0.5f) count++;
-	else count--;
-	if (count < 1) count = 1;
-	if (count > REP_MAXCOUNT) count = REP_MAXCOUNT;
-	nn->i1 = count;
-}
-
-
-int Geno_f4::MutateOneValid(f4_node *& g, int &method) const
+void Geno_f4::repeatNodeChangeRandom(f4_Node *nn) const
+{
+	if (rndDouble(1) < 0.5f) nn->reps++; else nn->reps--; // change count
+	if (nn->reps < 1) nn->reps = 1;
+	if (nn->reps > mut_max_rep) nn->reps = mut_max_rep;
+}
+
+
+int Geno_f4::MutateOneValid(f4_Node *& g, int &method) const
 // mutate one, until a valid genotype is obtained
 {
 	// ! the genotype is g->child (not g) !
 	int i, res;
-	f4_node *gcopy = NULL;
-	// try this max 20 times:
-	//   copy, mutate, then validate
-
-	for (i = 0; i < 20; i++)
+	f4_Node *gcopy = NULL;
+	const int TRY_MUTATE = 20;
+	// try this at most TRY_MUTATE times: copy, mutate, then validate
+	for (i = 0; i < TRY_MUTATE; i++)
 	{
 		gcopy = g->duplicate();
@@ -569,5 +546,5 @@
 int Geno_f4::mutate(char *& g, float & chg, int &method)
 {
-	f4_node *root = new f4_node;
+	f4_Node *root = new f4_Node;
 	if (f4_processrec(g, 0, root) || root->childCount() != 1)
 	{
@@ -600,6 +577,6 @@
 
 // convert to tree
-f4_node *root;
-root = new f4_node();
+f4_Node *root;
+root = new f4_Node();
 res = f4_processrec(g, 0, root);
 if (res) {
@@ -654,5 +631,5 @@
 
 
-int Geno_f4::CrossOverOne(f4_node *g1, f4_node *g2, float chg) const
+int Geno_f4::CrossOverOne(f4_Node *g1, f4_Node *g2, float chg) const
 {
 	// ! the genotypes are g1->child and g2->child (not g1 g2) !
@@ -660,10 +637,10 @@
 	int smin, smax;
 	float size;
-	f4_node *n1, *n2, *n1p, *n2p;
+	f4_Node *n1, *n2, *n1p, *n2p;
 
 	// determine desired size
 	size = (1 - chg) * (float)g1->count();
-	smin = (int)(size*0.9f - 1);
-	smax = (int)(size*1.1f + 1);
+	smin = (int)(size * 0.9f - 1);
+	smax = (int)(size * 1.1f + 1);
 	// get a random node with desired size
 	n1 = g1->child->randomNodeWithSize(smin, smax);
@@ -671,6 +648,6 @@
 	// determine desired size
 	size = (1 - chg) * (float)g2->count();
-	smin = (int)(size*0.9f - 1);
-	smax = (int)(size*1.1f + 1);
+	smin = (int)(size * 0.9f - 1);
+	smax = (int)(size * 1.1f + 1);
 	// get a random node with desired size
 	n2 = g2->child->randomNodeWithSize(smin, smax);
@@ -691,5 +668,5 @@
 int Geno_f4::crossOver(char *&g1, char *&g2, float &chg1, float &chg2)
 {
-	f4_node root1, root2, *copy1, *copy2;
+	f4_Node root1, root2, *copy1, *copy2;
 
 	// convert genotype strings into tree structures
@@ -720,8 +697,8 @@
 	// style categories
 #define STYL4CAT_MODIFIC F14_MODIFIERS ","
-#define STYL4CAT_NEUMOD "[]:+-/!="
+#define STYL4CAT_NEUMOD "/!="
 #define STYL4CAT_NEUSPECIAL "|@*"
-#define STYL4CAT_DIGIT "0123456789."
-#define STYL4CAT_REST "XN<># "
+#define STYL4CAT_DIGIT "+-0123456789.[]" //'+' is only for adjusting old-style properties "/!="
+#define STYL4CAT_REST ":XN<># "
 
 	if (!isalpha(ch) && !strchr(STYL4CAT_MODIFIC STYL4CAT_NEUMOD STYL4CAT_NEUSPECIAL STYL4CAT_DIGIT STYL4CAT_REST "\t", ch))
